// Objective-C API for talking to bitbucket.org/weproov/weproovstrucgo/items Go package.
//   gobind -lang=objc bitbucket.org/weproov/weproovstrucgo/items
//
// File is generated by gobind. Do not edit.

#ifndef __Items_H__
#define __Items_H__

@import Foundation;
#include "Universe.objc.h"

#include "Geoloc.objc.h"
#include "Pulldownload.objc.h"
#include "S3image.objc.h"
#include "Translations.objc.h"

@class ItemsChecklist;
@class ItemsFormItemStruct;
@class ItemsFormStruct;
@class ItemsInfo;
@class ItemsInfosParameters;
@class ItemsList;
@class ItemsProcess;
@class ItemsProcessInfos;
@class ItemsStruct;
@class ItemsSupport;
@protocol ItemsFormGetDelegate;
@class ItemsFormGetDelegate;
@protocol ItemsFormPostDelegate;
@class ItemsFormPostDelegate;
@protocol ItemsFullDelegate;
@class ItemsFullDelegate;
@protocol ItemsListDelegate;
@class ItemsListDelegate;

@protocol ItemsFormGetDelegate <NSObject>
- (void)formGetError:(NSError*)err;
- (void)formGetSuccess:(ItemsFormStruct*)form;
@end

@protocol ItemsFormPostDelegate <NSObject>
- (void)formPostError:(NSError*)err;
- (void)formPostSuccess;
@end

@protocol ItemsFullDelegate <NSObject>
- (void)onFullError:(NSError*)err;
- (void)onFullSuccess:(ItemsStruct*)item;
@end

@protocol ItemsListDelegate <NSObject>
- (void)onItemsFindError:(NSError*)err;
- (void)onItemsFindsuccess:(ItemsList*)list;
@end

@interface ItemsChecklist : NSObject <goSeqRefInterface> {
}
@property(strong, readonly) id _ref;

- (instancetype)initWithRef:(id)ref;
- (instancetype)init;
- (long)id_;
- (void)setId:(long)v;
- (NSString*)name;
- (void)setName:(NSString*)v;
- (NSString*)value;
- (void)setValue:(NSString*)v;
- (NSString*)type;
- (void)setType:(NSString*)v;
- (long)itemsId;
- (void)setItemsId:(long)v;
- (long)title;
- (void)setTitle:(long)v;
// skipped field Checklist.CreatedAt with unsupported type: *types.Named

// skipped field Checklist.UpdatedAt with unsupported type: *types.Named

// skipped field Checklist.Title_ with unsupported type: *types.Named

@end

@interface ItemsFormItemStruct : NSObject <goSeqRefInterface> {
}
@property(strong, readonly) id _ref;

- (instancetype)initWithRef:(id)ref;
- (instancetype)init;
- (long)id_;
- (void)setId:(long)v;
// skipped field FormItemStruct.CreatedAt with unsupported type: *types.Named

// skipped field FormItemStruct.UpdatedAt with unsupported type: *types.Named

- (long)title;
- (void)setTitle:(long)v;
// skipped field FormItemStruct.Title_ with unsupported type: *types.Named

- (NSString*)name;
- (void)setName:(NSString*)v;
- (NSString*)type;
- (void)setType:(NSString*)v;
- (NSString*)value;
- (void)setValue:(NSString*)v;
- (long)itemsId;
- (void)setItemsId:(long)v;
// skipped field FormItemStruct.Parameters with unsupported type: *types.Named

- (ItemsInfosParameters*)getParams;
- (NSString*)getTr;
@end

@interface ItemsFormStruct : NSObject <goSeqRefInterface> {
}
@property(strong, readonly) id _ref;

- (instancetype)initWithRef:(id)ref;
- (instancetype)init;
// skipped field FormStruct.FormItems with unsupported type: *types.Slice

- (long)categoryId;
- (void)setCategoryId:(long)v;
- (long)formItemsCount;
- (ItemsFormItemStruct*)formItemsGet:(long)index;
- (void)post:(id<ItemsFormPostDelegate>)delegate;
- (BOOL)postSync:(NSError**)error;
@end

@interface ItemsInfo : NSObject <goSeqRefInterface> {
}
@property(strong, readonly) id _ref;

- (instancetype)initWithRef:(id)ref;
- (instancetype)init;
- (long)id_;
- (void)setId:(long)v;
- (NSString*)name;
- (void)setName:(NSString*)v;
- (NSString*)value;
- (void)setValue:(NSString*)v;
- (NSString*)type;
- (void)setType:(NSString*)v;
- (long)itemsId;
- (void)setItemsId:(long)v;
- (long)title;
- (void)setTitle:(long)v;
// skipped field Info.CreatedAt with unsupported type: *types.Named

// skipped field Info.UpdatedAt with unsupported type: *types.Named

// skipped field Info.Title_ with unsupported type: *types.Named

- (NSString*)getFormatedRow;
@end

@interface ItemsInfosParameters : NSObject <goSeqRefInterface> {
}
@property(strong, readonly) id _ref;

- (instancetype)initWithRef:(id)ref;
- (instancetype)init;
// skipped field InfosParameters.List with unsupported type: *types.Slice

// skipped field InfosParameters.List_ with unsupported type: *types.Slice

- (long)getListIdByPosition:(NSString*)tr;
- (long)getListPosition:(long)pose;
- (NSString*)getListTr:(long)id_;
- (long)listCount;
@end

@interface ItemsList : NSObject <goSeqRefInterface> {
}
@property(strong, readonly) id _ref;

- (instancetype)initWithRef:(id)ref;
- (instancetype)init;
- (NSString*)find;
- (void)setFind:(NSString*)v;
- (long)offset;
- (void)setOffset:(long)v;
- (long)limit;
- (void)setLimit:(long)v;
- (BOOL)haveMore;
- (void)setHaveMore:(BOOL)v;
// skipped field List.Result with unsupported type: *types.Slice

- (long)count;
- (ItemsStruct*)get:(long)num;
- (void)next:(id<ItemsListDelegate>)delegate;
@end

@interface ItemsProcess : NSObject <goSeqRefInterface> {
}
@property(strong, readonly) id _ref;

- (instancetype)initWithRef:(id)ref;
- (instancetype)init;
- (long)id_;
- (void)setId:(long)v;
- (NSString*)name;
- (void)setName:(NSString*)v;
- (long)s3pictureId;
- (void)setS3pictureId:(long)v;
// skipped field Process.Picture_ with unsupported type: *types.Named

// skipped field Process.Infos with unsupported type: *types.Interface

- (NSString*)type;
- (void)setType:(NSString*)v;
- (long)itemsId;
- (void)setItemsId:(long)v;
- (long)title;
- (void)setTitle:(long)v;
// skipped field Process.CreatedAt with unsupported type: *types.Named

// skipped field Process.UpdatedAt with unsupported type: *types.Named

// skipped field Process.Title_ with unsupported type: *types.Named

- (NSData*)getData;
@end

@interface ItemsProcessInfos : NSObject <goSeqRefInterface> {
}
@property(strong, readonly) id _ref;

- (instancetype)initWithRef:(id)ref;
- (instancetype)init;
- (long)choice;
- (void)setChoice:(long)v;
- (long)index;
- (void)setIndex:(long)v;
- (NSString*)description;
- (void)setDescription:(NSString*)v;
- (double)height;
- (void)setHeight:(double)v;
- (double)width;
- (void)setWidth:(double)v;
- (double)left;
- (void)setLeft:(double)v;
- (double)top;
- (void)setTop:(double)v;
@end

@interface ItemsStruct : NSObject <goSeqRefInterface, PulldownloadDownloadable> {
}
@property(strong, readonly) id _ref;

- (instancetype)initWithRef:(id)ref;
- (instancetype)init;
- (long)id_;
- (void)setId:(long)v;
- (NSString*)identifieur;
- (void)setIdentifieur:(NSString*)v;
- (NSString*)name;
- (void)setName:(NSString*)v;
- (NSString*)value;
- (void)setValue:(NSString*)v;
- (NSString*)valueNorme;
- (void)setValueNorme:(NSString*)v;
- (NSString*)refStr;
- (void)setRefStr:(NSString*)v;
- (long)title;
- (void)setTitle:(long)v;
- (long)ownerId;
- (void)setOwnerId:(long)v;
// skipped field Struct.Geoloc with unsupported type: *types.Named

- (long)categoryId;
- (void)setCategoryId:(long)v;
- (long)s3pictureId;
- (void)setS3pictureId:(long)v;
// skipped field Struct.CreatedAt with unsupported type: *types.Named

// skipped field Struct.UpdatedAt with unsupported type: *types.Named

// skipped field Struct.Title_ with unsupported type: *types.Named

// skipped field Struct.Preview with unsupported type: *types.Named

// skipped field Struct.Infos with unsupported type: *types.Slice

// skipped field Struct.Checklists with unsupported type: *types.Slice

// skipped field Struct.Supports with unsupported type: *types.Slice

// skipped field Struct.Process with unsupported type: *types.Slice

/**
 * 	renvoy la version downloadable
 */
- (id<PulldownloadDownloadable>)asDownloadable;
/**
 * 	permet de preparer la structure pulldownload pour le telechargement
	des images
 */
- (PulldownloadStruct*)download:(id<PulldownloadManagerDelegate>)delegate;
/**
 * 	Permer de recuperer la totaliter des informations de l items
	de facons asynchrone
 */
- (void)getFull:(id<ItemsFullDelegate>)delegate;
/**
 * 	Permer de recuperer la totaliter des informations de l items
	de facons synchrone
 */
- (ItemsStruct*)getFullSync:(NSError**)error;
/**
 * 	Retourn une infos par raport a son index dans le tableau
 */
- (ItemsInfo*)getInfo:(long)num;
/**
 * 	Permet de faire passer la date du framework au app
 */
- (int64_t)getLastUpdateUnix;
/**
 * 	Permet de telecharger la preview d'une image
 */
- (void)getPreviewThumb:(id<S3imageThumbDelegate>)delegate;
/**
 * 	Renvoy la traduction du champs qui a ete utiliser pour
	l'identification du bien
 */
- (NSString*)getTr;
/**
 * 	Retourn le nombre d'infos actuellement dans l'item
 */
- (long)infoCount;
/**
 * 	check si le path s3 corespond a celui qui est passer en parametre
 */
- (BOOL)previewIs:(NSString*)path;
@end

@interface ItemsSupport : NSObject <goSeqRefInterface> {
}
@property(strong, readonly) id _ref;

- (instancetype)initWithRef:(id)ref;
- (instancetype)init;
- (long)id_;
- (void)setId:(long)v;
- (NSString*)name;
- (void)setName:(NSString*)v;
- (long)s3pictureId;
- (void)setS3pictureId:(long)v;
// skipped field Support.Picture_ with unsupported type: *types.Named

- (NSString*)type;
- (void)setType:(NSString*)v;
- (long)itemsId;
- (void)setItemsId:(long)v;
- (long)title;
- (void)setTitle:(long)v;
// skipped field Support.CreatedAt with unsupported type: *types.Named

// skipped field Support.UpdatedAt with unsupported type: *types.Named

// skipped field Support.Title_ with unsupported type: *types.Named

- (NSData*)getData;
@end

FOUNDATION_EXPORT void ItemsFormGet(NSString* formType, id<ItemsFormGetDelegate> delegate);

FOUNDATION_EXPORT ItemsFormStruct* ItemsFormGetSync(NSString* formType, NSError** error);

FOUNDATION_EXPORT void ItemsGetList(NSString* find, long offset, long limit, id<ItemsListDelegate> delegate);

FOUNDATION_EXPORT ItemsList* ItemsGetListSync(NSString* find, long offset, long limit, NSError** error);

@class ItemsFormGetDelegate;

@class ItemsFormPostDelegate;

@class ItemsFullDelegate;

@class ItemsListDelegate;

@interface ItemsFormGetDelegate : NSObject <goSeqRefInterface, ItemsFormGetDelegate> {
}
@property(strong, readonly) id _ref;

- (instancetype)initWithRef:(id)ref;
- (void)formGetError:(NSError*)err;
- (void)formGetSuccess:(ItemsFormStruct*)form;
@end

@interface ItemsFormPostDelegate : NSObject <goSeqRefInterface, ItemsFormPostDelegate> {
}
@property(strong, readonly) id _ref;

- (instancetype)initWithRef:(id)ref;
- (void)formPostError:(NSError*)err;
- (void)formPostSuccess;
@end

@interface ItemsFullDelegate : NSObject <goSeqRefInterface, ItemsFullDelegate> {
}
@property(strong, readonly) id _ref;

- (instancetype)initWithRef:(id)ref;
- (void)onFullError:(NSError*)err;
- (void)onFullSuccess:(ItemsStruct*)item;
@end

@interface ItemsListDelegate : NSObject <goSeqRefInterface, ItemsListDelegate> {
}
@property(strong, readonly) id _ref;

- (instancetype)initWithRef:(id)ref;
- (void)onItemsFindError:(NSError*)err;
- (void)onItemsFindsuccess:(ItemsList*)list;
@end

#endif
